<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Nama, kode bank" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button v-permission="[null, 'bank', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Bank
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="banks" ref="bankTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Nama Bank"
                width="300">
                <template slot-scope="scope">
                    <span style="color:#3E89FA;">{{ scope.row.name }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Deskripsi"
                width="300">
                <template slot-scope="scope">
                    <span>{{ scope.row.description }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Kode"
                width="100">
                <template slot-scope="scope">
                    <span>{{ scope.row.code }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Total Rekening"
                width="150">
                <template slot-scope="scope">
                    <el-tag v-if="scope.row.total_account.length > 0" type="success" size="mini"> <i class="ion-ios-card"></i> {{ scope.row.total_account }} rekening</el-tag>
                    <el-tag v-else type="info" size="mini"><i class="ion-ios-card"></i> {{ scope.row.total_account }} rekening</el-tag>
                </template>
            </el-table-column> 
            <el-table-column
                label="Terakhir Diubah"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'bank', 'viewother']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'bank', 'deleteother']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="bankForm" :model="bankForm" :rules="bankRules">
                <aside>
                    <el-alert type="info" description="Mengatur daftar semua bank yang ada di Indonesia yang akan digunakan oleh seluruh pengguna." :closable=false show-icon></el-alert>
                </aside>
                <el-row :gutter="20">
                    <el-col :lg="8" :md="24" :xs="24">
                        <el-form-item label="Kode Bank" prop="code">
                            <el-input type="number" ref="code" name="code" v-model="bankForm.code" placeholder="Kode bank" autocomplete="off" min="0" maxlength="6"></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="16" :md="24" :xs="24">
                        <el-form-item label="Nama Bank" prop="name">
                            <el-input ref="name" name="name" v-model="bankForm.name" placeholder="Nama bank" autocomplete="off" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-form-item label="Deskripsi" prop="description">
                    <el-input type="textarea" ref="description" name="description" v-model="bankForm.description" placeholder="Deskripsi bank" autocomplete="off" maxlength="255" :autosize="{ minRows: 2, maxRows: 4}" show-word-limit></el-input>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'bank', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>
            </span>
        </el-dialog>
    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';

export default {
    name: 'Bank',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        return {
            tableLoading: false,
            dialogLoading: false,
            filter: {
                keyword: ''
            },
            showDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Bank',
                create: 'Tambah Bank'
            },
            bankForm: {
                id: null,
                code: null,
                name: '',
                description: '',
                archived: false
            },
            bankRules: {
                code: [{ 
                    required: true, message: 'Kode bank wajib diisi', trigger: 'blur'
                }, {
                    max: 6, message: 'Panjang kode bank maksimal 6 karakter', trigger: 'blur'
                }, {
                    pattern: /^\d+$/, message: 'Hanya angka yang diperbolehkan', trigger: 'blur'
                }],
                name: [{ 
                    required: true, message: 'Nama bank wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang nama bank maksimal 255 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                description: [{ max: 255, message: 'Panjang deskripsi maksimal 255 karakter', trigger: 'blur'}]
            },
        };
    },
    computed: {
        tableHeight,
        ...mapGetters('bank', [
            'banks',
            'pagination'
        ]),
    },
    created() {
        this.getBanks();
    },
    methods: {
        playSound,
        dateFormat,
        getBanks() {
            this.tableLoading = true;
            this.$store.dispatch('bank/getBanks', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleSearch(){
            this.tableLoading = true;
            this.$store.dispatch('bank/getBanks', {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;          
            this.$nextTick(() => {
                this.$refs['bankForm'].clearValidate();
            });
        },
        handleEdit(bank){
            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.bankForm.id = bank.id;
            this.bankForm.code = bank.code;
            this.bankForm.name = bank.name;
            this.bankForm.description = bank.description;  
            this.bankForm.archived = bank.archived;
            this.$nextTick(() => {
                this.$refs['bankForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.bankForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'bank/addBank';
                        payload = {
                            code: this.bankForm.code,
                            name: this.bankForm.name,
                            description: this.bankForm.description
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'bank/editBank';
                        payload = {
                            id: this.bankForm.id,
                            code: this.bankForm.code,
                            name: this.bankForm.name,
                            description: this.bankForm.description,
                            archived: this.bankForm.archived
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(bank){
            this.$confirm('Anda mencoba untuk menghapus data bank, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('bank/deleteBank', {
                    id: bank.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.bankForm = {
                id: null,
                code: null,
                name: '',
                description: ''
            }
        }
    }

}
</script>
